aboutsummaryrefslogtreecommitdiffstats
path: root/testsuite/vhpi
diff options
context:
space:
mode:
authorMarlon James <marlon.james@gmail.com>2021-03-03 12:06:53 -0800
committertgingold <tgingold@users.noreply.github.com>2021-03-04 07:49:28 +0100
commit062ff5b6a41caf93e03c417e31a8a6471993abf1 (patch)
treefcc773b7c6a153e911120ee611945bb3347e91c2 /testsuite/vhpi
parent783cbac7ba4c14aa7e27f28755dccd7e4ee4d54e (diff)
downloadghdl-062ff5b6a41caf93e03c417e31a8a6471993abf1.tar.gz
ghdl-062ff5b6a41caf93e03c417e31a8a6471993abf1.tar.bz2
ghdl-062ff5b6a41caf93e03c417e31a8a6471993abf1.zip
VHPI: add tests for loading libraries
Diffstat (limited to 'testsuite/vhpi')
-rw-r--r--testsuite/vhpi/001load_lib/mydesign.vhdl9
-rwxr-xr-xtestsuite/vhpi/001load_lib/testsuite.sh32
-rw-r--r--testsuite/vhpi/001load_lib/vhpi_lib.c13
-rw-r--r--testsuite/vhpi/002load_entrypoint/mydesign.vhdl9
-rwxr-xr-xtestsuite/vhpi/002load_entrypoint/testsuite.sh32
-rw-r--r--testsuite/vhpi/002load_entrypoint/vhpi_lib.c7
-rw-r--r--testsuite/vhpi/003load_multi_lib/mydesign.vhdl9
-rwxr-xr-xtestsuite/vhpi/003load_multi_lib/testsuite.sh38
-rw-r--r--testsuite/vhpi/003load_multi_lib/vhpi_lib1.c7
-rw-r--r--testsuite/vhpi/003load_multi_lib/vhpi_lib2.c7
-rwxr-xr-xtestsuite/vhpi/testsuite.sh5
11 files changed, 168 insertions, 0 deletions
diff --git a/testsuite/vhpi/001load_lib/mydesign.vhdl b/testsuite/vhpi/001load_lib/mydesign.vhdl
new file mode 100644
index 000000000..38fdfda98
--- /dev/null
+++ b/testsuite/vhpi/001load_lib/mydesign.vhdl
@@ -0,0 +1,9 @@
+library ieee ;
+use ieee.std_logic_1164.all;
+
+entity myentity is
+end myentity;
+
+architecture arch of myentity is
+begin
+end arch;
diff --git a/testsuite/vhpi/001load_lib/testsuite.sh b/testsuite/vhpi/001load_lib/testsuite.sh
new file mode 100755
index 000000000..1a23b1b69
--- /dev/null
+++ b/testsuite/vhpi/001load_lib/testsuite.sh
@@ -0,0 +1,32 @@
+#! /bin/sh
+
+. ../../testenv.sh
+
+analyze mydesign.vhdl
+elab myentity
+
+if c_compiler_is_available && ghdl_has_feature myentity vhpi; then
+ $GHDL --vpi-compile -v gcc -c vhpi_lib.c
+ $GHDL --vpi-link -v gcc -o vhpi_lib.vhpi vhpi_lib.o
+
+ add_vpi_path
+
+ simulate myentity --vhpi=./vhpi_lib.vhpi | tee myentity.out
+ if grep -q Error myentity.out; then
+ echo "Error in output"
+ exit 1;
+ fi
+ if grep -q error myentity.out; then
+ echo "error in output"
+ exit 1;
+ fi
+ if ! grep -q "VHPI lib" myentity.out; then
+ echo "VHPI Library not loaded"
+ exit 1;
+ fi
+
+ rm -f vhpi_lib.vhpi vhpi_lib.o myentity.out
+fi
+clean
+
+echo "Test successful"
diff --git a/testsuite/vhpi/001load_lib/vhpi_lib.c b/testsuite/vhpi/001load_lib/vhpi_lib.c
new file mode 100644
index 000000000..46b70ede4
--- /dev/null
+++ b/testsuite/vhpi/001load_lib/vhpi_lib.c
@@ -0,0 +1,13 @@
+#include <stdio.h>
+#include <vpi_user.h>
+
+void my_startup()
+{
+ printf ("VHPI lib\n");
+}
+
+void (*vhpi_startup_routines[]) () =
+{
+ my_startup,
+ 0
+};
diff --git a/testsuite/vhpi/002load_entrypoint/mydesign.vhdl b/testsuite/vhpi/002load_entrypoint/mydesign.vhdl
new file mode 100644
index 000000000..38fdfda98
--- /dev/null
+++ b/testsuite/vhpi/002load_entrypoint/mydesign.vhdl
@@ -0,0 +1,9 @@
+library ieee ;
+use ieee.std_logic_1164.all;
+
+entity myentity is
+end myentity;
+
+architecture arch of myentity is
+begin
+end arch;
diff --git a/testsuite/vhpi/002load_entrypoint/testsuite.sh b/testsuite/vhpi/002load_entrypoint/testsuite.sh
new file mode 100755
index 000000000..bdc2e8a6a
--- /dev/null
+++ b/testsuite/vhpi/002load_entrypoint/testsuite.sh
@@ -0,0 +1,32 @@
+#! /bin/sh
+
+. ../../testenv.sh
+
+analyze mydesign.vhdl
+elab myentity
+
+if c_compiler_is_available && ghdl_has_feature myentity vhpi; then
+ $GHDL --vpi-compile -v gcc -c vhpi_lib.c
+ $GHDL --vpi-link -v gcc -o vhpi_lib.vhpi vhpi_lib.o
+
+ add_vpi_path
+
+ simulate myentity --vhpi=./vhpi_lib.vhpi:my_startup | tee myentity.out
+ if grep -q Error myentity.out; then
+ echo "Error in output"
+ exit 1;
+ fi
+ if grep -q error myentity.out; then
+ echo "error in output"
+ exit 1;
+ fi
+ if ! grep -q "VHPI lib" myentity.out; then
+ echo "VHPI Library not loaded"
+ exit 1;
+ fi
+
+ rm -f vhpi_lib.vhpi vhpi_lib.o myentity.out
+fi
+clean
+
+echo "Test successful"
diff --git a/testsuite/vhpi/002load_entrypoint/vhpi_lib.c b/testsuite/vhpi/002load_entrypoint/vhpi_lib.c
new file mode 100644
index 000000000..414eac731
--- /dev/null
+++ b/testsuite/vhpi/002load_entrypoint/vhpi_lib.c
@@ -0,0 +1,7 @@
+#include <stdio.h>
+#include <vpi_user.h>
+
+void my_startup()
+{
+ printf ("VHPI lib\n");
+}
diff --git a/testsuite/vhpi/003load_multi_lib/mydesign.vhdl b/testsuite/vhpi/003load_multi_lib/mydesign.vhdl
new file mode 100644
index 000000000..38fdfda98
--- /dev/null
+++ b/testsuite/vhpi/003load_multi_lib/mydesign.vhdl
@@ -0,0 +1,9 @@
+library ieee ;
+use ieee.std_logic_1164.all;
+
+entity myentity is
+end myentity;
+
+architecture arch of myentity is
+begin
+end arch;
diff --git a/testsuite/vhpi/003load_multi_lib/testsuite.sh b/testsuite/vhpi/003load_multi_lib/testsuite.sh
new file mode 100755
index 000000000..a8c3772b5
--- /dev/null
+++ b/testsuite/vhpi/003load_multi_lib/testsuite.sh
@@ -0,0 +1,38 @@
+#! /bin/sh
+
+. ../../testenv.sh
+
+analyze mydesign.vhdl
+elab myentity
+
+if c_compiler_is_available && ghdl_has_feature myentity vhpi; then
+ $GHDL --vpi-compile -v gcc -c vhpi_lib1.c
+ $GHDL --vpi-link -v gcc -o vhpi_lib1.vhpi vhpi_lib1.o
+ $GHDL --vpi-compile -v gcc -c vhpi_lib2.c
+ $GHDL --vpi-link -v gcc -o vhpi_lib2.vhpi vhpi_lib2.o
+
+ add_vpi_path
+
+ simulate myentity --vhpi=./vhpi_lib1.vhpi:my_startup --vhpi=./vhpi_lib2.vhpi:my_startup | tee myentity.out
+ if grep -q Error myentity.out; then
+ echo "Error in output"
+ exit 1;
+ fi
+ if grep -q error myentity.out; then
+ echo "error in output"
+ exit 1;
+ fi
+ if ! grep -q "VHPI lib 1" myentity.out; then
+ echo "VHPI Library 1 not loaded"
+ exit 1;
+ fi
+ if ! grep -q "VHPI lib 2" myentity.out; then
+ echo "VHPI Library 2 not loaded"
+ exit 1;
+ fi
+
+ rm -f vhpi_lib1.vhpi vhpi_lib1.o vhpi_lib2.vhpi vhpi_lib2.o myentity.out
+fi
+clean
+
+echo "Test successful"
diff --git a/testsuite/vhpi/003load_multi_lib/vhpi_lib1.c b/testsuite/vhpi/003load_multi_lib/vhpi_lib1.c
new file mode 100644
index 000000000..3a9ceaf2a
--- /dev/null
+++ b/testsuite/vhpi/003load_multi_lib/vhpi_lib1.c
@@ -0,0 +1,7 @@
+#include <stdio.h>
+#include <vpi_user.h>
+
+void my_startup()
+{
+ printf ("VHPI lib 1\n");
+}
diff --git a/testsuite/vhpi/003load_multi_lib/vhpi_lib2.c b/testsuite/vhpi/003load_multi_lib/vhpi_lib2.c
new file mode 100644
index 000000000..b1f6c7119
--- /dev/null
+++ b/testsuite/vhpi/003load_multi_lib/vhpi_lib2.c
@@ -0,0 +1,7 @@
+#include <stdio.h>
+#include <vpi_user.h>
+
+void my_startup()
+{
+ printf ("VHPI lib 2\n");
+}
diff --git a/testsuite/vhpi/testsuite.sh b/testsuite/vhpi/testsuite.sh
new file mode 100755
index 000000000..e97a19ba0
--- /dev/null
+++ b/testsuite/vhpi/testsuite.sh
@@ -0,0 +1,5 @@
+#! /bin/sh
+
+set -e
+
+$(dirname "$0")/../suite_driver.sh vhpi $@